import pytest
from importers.common.helpers import isodate


@pytest.mark.parametrize("annons_date, expected_date",
                         [('2021-03-19 12:41:52', '2021-03-19T12:41:52'),
                          ('2021-04-18 23:59:59', '2021-04-18T23:59:59'),
                          ('2022-06-14 07:38:46', '2022-06-14T07:38:46'),
                          ('2021-03-18 00:00:00', '2021-03-18T00:00:00'),
                          ('2021-04-16 23:59:59', '2021-04-16T23:59:59'),
                          ('2022-06-14 14:33:12', '2022-06-14T14:33:12'),
                          ('2020-09-30 14:35:20', '2020-09-30T14:35:20'),
                          ('2021-03-29 23:59:59', '2021-03-29T23:59:59'),
                          ('2022-06-14 14:33:59', '2022-06-14T14:33:59'),
                          ('2021-01-04 16:18:13', '2021-01-04T16:18:13'),
                          ('2021-03-31 23:59:59', '2021-03-31T23:59:59'),
                          ('2022-06-14 14:52:55', '2022-06-14T14:52:55'),
                          ('2021-01-04 16:18:13', '2021-01-04T16:18:13'),
                          ('2021-03-31 23:59:59', '2021-03-31T23:59:59'),
                          ('2021-02-01 10:57:26', '2021-02-01T10:57:26'),
                          ('2021-04-27 23:59:59', '2021-04-27T23:59:59'),
                          ('2022-06-14 14:55:21', '2022-06-14T14:55:21')])
def test_dates(annons_date, expected_date):
    converted = isodate(annons_date)
    assert converted == expected_date


@pytest.mark.parametrize("annons_date, expected_date",
                         [(None, None),
                          ('20210418235959', '2021-04-18T23:59:59'),
                          ('2022/06/14 07:38:46', '2022-06-14T07:38:46'),
                          ('2022-06-14 07:38:46', '2022-06-14T07:38:46'),
                          ('2022-06-14 07:38:46', '2022-06-14T07:38:46'),
                          ('2022+06+14 07:38:46', None),
                          (' ', None)
                          ])
def test_wrong_dates(annons_date, expected_date):
    converted = isodate(annons_date)
    assert converted == expected_date


@pytest.mark.parametrize("annons_date", [
    ['2022+06+14 07:38:46'],
    {'2022+06+14 07:38:46'},
    {'date': '2022+06+14 07:38:46'}
])
def test_dates_error(annons_date):
    with pytest.raises(TypeError):
        isodate(annons_date)
